#!/usr/bin/python

import sys, os.path, zipfile

if len(sys.argv) == 1:
	print "Usage:", sys.argv[0], "[target]"
	print "Possible targets are: build, install, pkg, pkg-src"
	sys.exit(0)

install_dest = "~/Library/Application Support/TextWrangler/Language Modules/"
install_dest = os.path.expanduser(install_dest)

def format_keyword(kword):
	return "\t\t<string>" + kword + "</string>\n"

def add_to_zip(zip, file):
	global folder
	zip.write(file, folder + '/' + file)

def require_built():
	if not os.path.exists("WML.plist"):
		print "You need to build first!"
		sys.exit(1)

if sys.argv[1] == 'build':
	wml_plist = ""
	with open("header.txt") as header:
		wml_plist += header.read() + '\n'
	with open("tag-keywords.txt") as tags:
		for kword in tags:
			kword = kword.strip()
			wml_plist += format_keyword('[' + kword + ']')
			wml_plist += format_keyword('[+' + kword + ']')
			wml_plist += format_keyword('[/' + kword + ']')
			wml_plist += format_keyword('[' + kword + '][/' + kword + ']')
	pp_tags = []
	with open("pp-keywords.txt") as pp:
		for kword in pp:
			kword = kword.strip()
			pp_tags.append(kword)
			wml_plist += format_keyword('#' + kword)
	with open("footer.txt") as footer:
		wml_plist += footer.read().replace("--PP_TAGS--",'|'.join(pp_tags))
	with open("WML.plist",'w') as output:
		output.write(wml_plist)
elif sys.argv[1] == 'install':
	require_built()
	with open("WML.plist") as to_move:
		wml_plist = to_move.read()
	with open(install_dest + "WML.plist", 'w') as dest_file:
		dest_file.write(wml_plist)
elif sys.argv[1] == 'pkg':
	require_built()
	folder = 'wml-bblm'
	with zipfile.ZipFile(folder + ".zip", 'w') as archive:
		add_to_zip(archive, "INSTALL.txt")
		add_to_zip(archive, "README.txt")
		add_to_zip(archive, "setup.py")
		add_to_zip(archive, "WML.plist")
		add_to_zip(archive, "FAI.plist")
elif sys.argv[1] == 'pkg-src':
	folder = 'wml-bblm-src'
	with zipfile.ZipFile(folder + ".zip", 'w') as archive:
		add_to_zip(archive, "INSTALL.txt")
		add_to_zip(archive, "README.txt")
		add_to_zip(archive, "setup.py")
		add_to_zip(archive, "footer.txt")
		add_to_zip(archive, "header.txt")
		add_to_zip(archive, "tag-keywords.txt")
		add_to_zip(archive, "pp-keywords.txt")
else:
	print "Unknown target!"